Subject: bug#68668: 30.0.50; Invalid hash table test: tab-bar--auto-width-hash-test

From: Mattias Engdegård <[email-masked]>
Date: Wed, 31 Jan 2024 12:55:05 +0100

31 jan. 2024 kl. 11.29 skrev Gerd Möllmann <[email-masked]>:

> That's get_hash_table_user_test in fns.c which only keeps the first
> occurrence of user-defined hash tests which have the same definition.

Oops, sorry about that. Thank you for finding this anomaly!

It's indeed a bit unexpected. It doesn't affect hash table operations as such, only the output of `hash-table-test` and the print representation. However, this means that a hash table couldn't be deserialised under some circumstances, which is a problem.

A correction has been pushed (7e85311a911).

I'm still not really satisfied with the current implementation of user-defined tests. I have a patch which turns hash-table tests into Lisp objects but it seems to slow down basic operations for some reason which is why I haven't used it yet.